#include <IRG/Model/Wavefront.hxx>
#include <fstream>
#include <sstream>

namespace IRG { namespace Model {

    Mesh Wavefront::Load(const std::string& filename) {

        /* Open model file. */
        std::ifstream ifs(filename, std::ios::in);

        /* Create resulting mesh. */
        Mesh result;

        /* Read until end-of-file is reached. */
        while (!ifs.eof()) {
            
            /* Read next line. */
            std::string line;
            std::getline(ifs, line);
            std::istringstream ss(line);

            /* Read first token. */
            std::string token;
            ss >> token;

            /* Decode token. */
            if (token == "v") {

                /* Double the storage capacity of vertices array if required. */
                if (result.m_Vertices->capacity() == result.m_Vertices->size()) {
                    result.m_Vertices->reserve(2 * result.m_Vertices->capacity());
                }

                /* Read and add vertex to array. */
                Math::Vector3f vertex = ReadVector<3>(ss);
                result.m_Vertices->push_back(vertex);

            } else if (token == "vt") {

                /* Double the storage capacity of texture coordinate array if required. */
                if (result.m_TexCoords->capacity() == result.m_TexCoords->size()) {
                    result.m_TexCoords->reserve(2 * result.m_TexCoords->capacity());
                }

                /* Read and add texture coordinate to array. */
                Math::Vector2f texCoord = ReadVector<2>(ss);
                result.m_TexCoords->push_back(texCoord);

            } else if (token == "vn") {

                /* Double the storage capacity of normal array if required. */
                if (result.m_Normals->capacity() == result.m_Normals->size()) {
                    result.m_Normals->reserve(2 * result.m_Normals->capacity());
                }

                /* Read and add normal to array. */
                Math::Vector3f normal = ReadVector<3>(ss);
                result.m_Normals->push_back(normal);

            } else if (token == "f") {

                /* Double the storage capacity of face array if required. */
                if (result.m_Faces->capacity() == result.m_Faces->size()) {
                    result.m_Faces->reserve(2 * result.m_Faces->capacity());
                }

                /* Read and add face to array. */
                std::vector<Math::Vector3i> face = ReadFace(ss);
                result.m_Faces->push_back(face);

            }

        }

        /* Return loaded mesh. */
        return result;

    }

    void Wavefront::Dump(const Mesh& mesh, std::ostream& ofs) {

        /* Dump first comment. */
        ofs << "# Generated by IRG program" << std::endl << std::endl;

        /* Dump all vertices. */
        ofs << "# Vertices" << std::endl;
        for (const Math::Vector3f& vertex : (*mesh.m_Vertices)) {
            ofs << "v " << vertex[0] << " " << vertex[1] << " " << vertex[2] << std::endl;
        }
        ofs << std::endl;

        /* Dump all texture coordinates. */
        ofs << "# Texture coords" << std::endl;
        for (const Math::Vector2f& texCoord : (*mesh.m_TexCoords)) {
            ofs << "vt " << texCoord[0] << " " << texCoord[1] << std::endl;
        }
        ofs << std::endl;

        /* Dump all vertices. */
        ofs << "# Normals" << std::endl;
        for (const Math::Vector3f& normal : (*mesh.m_Normals)) {
            ofs << "vn " << normal[0] << " " << normal[1] << " " << normal[2] << std::endl;
        }
        ofs << std::endl;

        /* Dump all faces. */
        ofs << "# Faces" << std::endl;
        for (const std::vector<Math::Vector3i>& face : (*mesh.m_Faces)) {
            ofs << "f";
            for (const Math::Vector3i& index : face) {
                ofs << " " << (index[0] + 1);
                if ((index[1] != -1) || (index[2] != -1)) {
                    ofs << "/";
                    if (index[1] != -1) ofs << (index[1] + 1);
                    if (index[2] != -1) ofs << "/" << (index[2] + 1);
                }
            }
            ofs << std::endl;
        }
        ofs << std::endl;

    }

    template<std::size_t N>
    Math::Vector<N, float> Wavefront::ReadVector(std::istringstream& line) {

        /* Create resulting vector. */
        Math::Vector<N, float> result;

        /* Read vector components. */
        for (std::size_t i = 0; (i < N) && (!line.eof()); ++i) {
            line >> result[i];
        }

        /* Return resulting vector. */
        return result;

    }

    std::vector<Math::Vector3i> Wavefront::ReadFace(std::istringstream& line) {

        /* Create resulting vector. */
        std::vector<Math::Vector3i> result;

        /* Read all triplets. */
        while (!line.eof()) {

            /* Create vertex index. */
            Math::Vector3i index;

            /* Read one triplet. */
            std::string triplet;
            line >> triplet;
            std::istringstream ss(triplet);

            /* Read all present indices. */
            for (std::size_t i = 0; (i < 3) && (!ss.eof()); ++i) {

                /* Read next value. */
                std::string value;
                std::getline(ss, value, '/');

                /* Write value to vertex index. */
                std::istringstream(value) >> index[i];

            }

            /* Add vertex index with adjusted indices to array. */
            result.push_back(index - Math::Vector3i(1));

        }

        /* Return resulting vector. */
        return result;

    }

} }
